/*
 * @(#)AgletFinder.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import java.util.*;

public class AgletFinder extends Aglet {

   public void onCreation(Object init) {
      getAgletContext().setProperty("AgletFinder", getAgletContext().getAgletProxy(getAgletID()));
   }

   Hashtable _database = new Hashtable();

   public boolean handleMessage(Message msg) {
      if (msg.sameKind("Lookup")) {
         print("Handling \'Lookup\': " + msg.getArg());
	 msg.sendReply(_database.get(msg.getArg()));
      } else if (msg.sameKind("Register")) {
         print("handling \'Register\': " + msg.getArg());
	 _database.put(msg.getArg("NAME"), msg.getArg("PROXY"));
      } else if (msg.sameKind("Unregister")) {
         print("handling \'Unregister\': " + msg.getArg());
	 _database.remove(msg.getArg("NAME"));
      }
      return true;
   }

   static public String NAME = "AgletFinder";
   private void print(String s) { System.out.println(NAME + ": " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}

