/*
 * @(#)CloningExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;

public class CloningExample extends Aglet {

   boolean _theClone = false;

   public void onCreation(Object o) {
   	addCloneListener(
   	   new CloneAdapter() {
	      public void onCloning(CloneEvent e) {
                 print("\'onCloning()\' is starting...");
	      	 try {
                    print("\'onCloning()\': Cloned by \'" + e.getAgletProxy().getAgletID() + "\'");
		 } catch (InvalidAgletException iae) { }
		 pause();
                 print("\'onCloning()\' is finishing.");
              }
	      public void onClone(CloneEvent e) {
                 _theClone = true;  //-- Yes, I am the clone.
		 print("\'onClone()\' is starting...");
                 pause();
                 print("\'onClone()\' is finishing.");
              }
	      public void onCloned(CloneEvent e) {
		 print("\'onCloned()\' is starting...");
                 pause();
                 print("\'onCloned()\' is finishing.");
              }
           }
        );
   }

   public void run() {
      if (!_theClone) {
         print("STARTING --------------------");
         print("\'run()\' is starting...");
         pause();
         print("Cloning...");
         try {
            clone();
            print("Finished cloning.");
         } catch (Exception e) {
            print("Failed to clone.");
            print(e.getMessage());
         }
         pause(); pause();
         print("\'run()\' is finishing.");
      } else {
         print("\'run()\' is starting...");
         pause();
         print("\'run()\' is finishing.");
      }
   }

   static public String NAME = "Cloning";
   void print(String s) { System.out.println(NAME + (_theClone ? "    (clone): " : " (original): ") + s); }
   private static long SLEEP = 3000;
   void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}

