/*
 * @(#)ControllerExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import java.net.URL;
import java.util.*;

public class ControllerExample extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
         print("Creating the child...");
         AgletProxy proxy = getAgletContext().createAglet(getCodeBase(),
       	                                                  "agletbook.ControllerChild",
       	                                                  null);
         print("Finished creating the child.");
	 pause();
	 // Creates the travel itinerary.
	 Vector itinerary = new Vector();
	 itinerary.addElement(new URL("atp://killi.genmagic.com:400"));
	 itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
	 itinerary.addElement(new URL("atp://killi.genmagic.com:400"));
	 itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
	 itinerary.addElement(new URL("atp://killi.genmagic.com:400"));
	 itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
	 Enumeration enum = itinerary.elements();
	 // Control the travel of the child.
	 while (enum.hasMoreElements()) {
	    print("Dispathing...");
	    proxy = proxy.dispatch((URL)enum.nextElement());
	    pause();pause();
	 }
	 print("Finished the child's itinerary.");
	 pause();
      } catch (Exception e) {
         print("Failed to create and dispose of the child.");
         print(e.getMessage());
      }
   }

   static public String NAME = "ControllerExample";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}



