/*
 * @(#)DeactivationExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;

public class DeactivationExample extends Aglet {

   private static long SECOND = 1000;

   boolean _activated = false;

   public void onCreation(Object o) {
   	addPersistencyListener(
   	   new PersistencyAdapter() {
	      public void onDeactivating(PersistencyEvent e) {
                 print("\'onDeactivating()\' is starting...");
                 print("\'onDeactivating()\': Duration is \'" + e.getDuration() + "\'");
                 pause();
                 print("\'onDeactivating()\' is finishing.");
              }
              public void onActivation(PersistencyEvent e) {
                 _activated = true;  //-- Yes, I am the activated aglet.
                 print("\'onActivation()\' is starting...");
                 pause();
                 print("\'onActivation()\' is finishing.");
              }
	   }
        );
   }

   public void run() {
      if (!_activated) {
         print("STARTING --------------------");
         print("\'run()\' is starting...");
         pause();
         print("Deactivating itself...");
         try {
            deactivate(10 * SECOND);
            print("You should never see this on your console!");
         } catch (Exception e) {
            print("Failed to deactivate itself.");
            print(e.getMessage());
         }
         pause(); pause();
         print("\'run()\' is finishing.");
      } else {
         print("\'run()\' is starting...");
         pause();
         print("\'run()\' is finishing.");
      }
   }

   static public String NAME = "Deactivation";
   void print(String s) { System.out.println(NAME + (_activated ? " (activated): " : "  (original): ") + s); }
   private static long SLEEP = 3000;
   void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}

