/*
 * @(#)FutureExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;

public class FutureExample extends Aglet {

   static private int Future = 4;

   public void run() {
      print("STARTING --------------------");
      try {
         print("Creating the child...");
         AgletProxy proxy = getAgletContext().createAglet(getCodeBase(),
                                                          "agletbook.FutureChild",
                                                          null);
         print("Finished creating the child.");
	 pause();
         try {
            print("Sends a message...");
            FutureReply future = proxy.sendAsyncMessage(new Message("Please reply"));
            print("The message was sent.");
            while (!future.isAvailable())               // Checks whether a reply is available.
               doIncrement();                           // If not: do incremental work...
            String reply = (String)future.getReply();   // Gets the reply.
	    print("Got the reply: \'" + reply + "\'");
         } catch (NotHandledException e) {
            print("Failed to send the message.");
            print(e.getMessage());
         }
      } catch (Exception e) {
         print("Failed to create the child.");
         print(e.getMessage());
      }
   }

   void doIncrement() {
      print("Working...");
      shortPause();
   }

   static public String NAME = "Future";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
   private void shortPause() { try { Thread.sleep(SLEEP/4); } catch (InterruptedException ie) { } }
}






