/*
 * @(#)Itinerary.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import java.net.*;
import java.io.*;

public abstract class Itinerary implements Serializable {

   protected URL _origin = null;
   protected AgletProxy _aglet = null;

   public Itinerary(URL origin) {
      _origin = origin;
   }

   public void init(Aglet aglet) {
      _aglet = aglet.getAgletContext().getAgletProxy(aglet.getAgletID());
      go();
   }

   public URL getOrigin() {
      return _origin;
   }

   public AgletProxy getAglet() {
      return _aglet;
   }

   protected void go(URL destination) throws Exception {
      _aglet.dispatch(destination);
   }

   public abstract void go();

   public abstract boolean hasMoreDestinations();

   public abstract URL getNextDestination();
}



