/*
 * @(#)ListingAgletMaster1.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import java.net.URL;
import java.util.*;
import java.io.*;

public class ListingAgletMaster1 extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
         URL destination = new URL("atp://killi.genmagic.com");
	 Object[] args = new Object[] { new File("C:"), getAgletContext().getAgletProxy(getAgletID()) };
	 AgletProxy proxy = getAgletContext().createAglet(getCodeBase(), "agletbook.ListingAglet1", args);
	 proxy = proxy.dispatch(destination);
      } catch (Exception e) {
         print("Failed to create the child.");
         print(e.getMessage());
      }
   }

   public boolean handleMessage(Message msg) {
      print("is handling a message...");
      if (msg.sameKind("Listing")) {
         String[] list = (String[])msg.getArg();
         for (int i = 0; i < list.length; )
            System.out.println(i + ": " + list[i++]);
         return true;     // Yes, I handled this message.
      } else
         return false;    // No, I did not handle this message.
   }

   static public String NAME = "ListingAgletMaster1";
   private void print(String s) { System.out.println(NAME + ": " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}



