/*
 * @(#)MsgParallelExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;

public class MsgParallelExample extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
         print("Creating the child...");
         AgletProxy proxy = getAgletContext().createAglet(getCodeBase(),
      	                                                 "agletbook.MsgParallelChild",
      	                                                 null);
         print("Finished creating the child.");
	 try {
            print("Start sending the messages...");
            proxy.sendAsyncMessage(new Message("One"));
            print("Message \'One\' was send and I can continue...");
            proxy.sendAsyncMessage(new Message("Two"));
            print("Message \'Two\' was send and I can continue...");
            proxy.sendAsyncMessage(new Message("Three"));
            print("Message \'Three\' was send.");
            print("Finished sending the messages.");
         } catch (Exception e) {
            print("Failed to send a message.");
            print(e.getMessage());
         }
      } catch (Exception e) {
         print("Failed to create the child.");
         print(e.getMessage());
      }
   }

   static public String NAME = "Message Parallel";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}




