/*
 * @(#)MsgSuspendChild.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;

public class MsgSuspendChild extends Aglet {

   public void onCreation(Object obj) {
      try {
         print("Suspending the incoming messages...");
         getMessageManager().suspend();
      } catch (Exception e) {
         System.out.println(e.getMessage());
      }
   }



   public void run() {
      print("Waiting...");
      pause();
      print("Waiting...");
      pause();
      print("Waiting...");
      pause();
      try {
         print("Now, resume message reception...");
         getMessageManager().resume();
      } catch (Exception e) {
         print("Failed to resume.");
         print(e.getMessage());
      }
   }

   public boolean handleMessage(Message msg) {
      print("Received a message...");
      if (msg.sameKind("One")) {
     	 print("Message \'One\' - starting...");
    	 pause();
     	 print("Message \'One\' - finished.");
         return true;
      } else if (msg.sameKind("Two")) {
     	 print("Message \'Two\' - starting...");
    	 pause();
    	 print("Message \'Two\' - finished.");
     	 return true;
      } else if (msg.sameKind("Three")) {
     	 print("Message \'Three\' - starting...");
    	 pause();
    	 print("Message \'Three\' - finished.");
     	 return true;
      }
      return false;
   }

   private void print(String s) { System.out.println(MsgSuspendExample.NAME + "  (child): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}




