/*
 * @(#)ParallelExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.util.*;

public class ParallelExample extends Aglet {

   public void onCreation(Object init) {
      AgletContext context = getAgletContext();
      ReplySet replies = new ReplySet();
      Message doTask = new Message("DoTask");
      Vector itinerary = new Vector();
      try {
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
         itinerary.addElement(new URL("atp://killi.genmagic.com:434"));
      } catch (Exception e) {
         print("Failed to create itinerary.");
	 print(e.getMessage());
      } 
      Enumeration enum = itinerary.elements();
      // Control the travel of the child.
      while (enum.hasMoreElements()) {
	 try {
            print("Dispathing...");
            AgletProxy worker = context.createAglet(getCodeBase(), "agletbook.Worker", null);
            worker = worker.dispatch((URL)enum.nextElement());
            replies.addFutureReply(worker.sendFutureMessage(doTask));
	 } catch (Exception e) {
            print("Failed to dispatch.");
	    print(e.getMessage());
         }
      }
      print("Getting replies...");
      while (replies.hasMoreFutureReplies()) {
         try {
            FutureReply future = replies.getNextFutureReply();
	    print((String)future.getReply());
	 } catch (Exception e) {
            print("Failed to receive reply.");
	    print(e.getMessage());
	 }
      }
      print("Finished.");
   }

   static public String NAME = "ParallelExample";
   private void print(String s) { System.out.println(NAME + ": " + s); }
   static long SLEEP = 3000;
   void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}





