/*
 * @(#)ProxyInfoExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;
import java.util.Enumeration;
import java.util.Date;

public class ProxyInfoExample extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
         print("Creating the child...");
         AgletProxy proxy = getAgletContext().createAglet(getCodeBase(), 
       	                                                  "agletbook.ProxyInfoChild", 
       	                                                  null);
         print("Finished creating the child.");
	 pause();
	 print("Using the proxy directly:");
         print("Identifier:    \'" + proxy.getAgletID() + "\'");
         print("Code Base:     \'" + "(Depreciated, using aglet.getCodeBase()) " + getCodeBase() + "\'");
         print("Class Name:    \'" + proxy.getAgletClassName() + "\'");
	 pause();
         print("... And now using the Info object:");
	 AgletInfo info = proxy.getAgletInfo();
	 print("Identifier:    \'" + info.getAgletID() + "\'");
	 print("Code Base:     \'" + info.getCodeBase() + "\'");
	 print("Class Name:    \'" + info.getAgletClassName() + "\'");
	 print("Origin:        \'" + info.getOrigin() + "\'");
	 print("Address:       \'" + info.getAddress() + "\'");
	 print("Creation Time: \'" + new Date(info.getCreationTime()) + "\'");
      } catch (Exception e) { 
         print("Failed to create the child.");
         print(e.getMessage());
      }
   }

   static public String NAME = "ProxyInfoExample";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}



