/*
 * @(#)ProxyListing.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;
import java.util.Enumeration;

public class ProxyListing extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
         print("Listing current proxies...");
         Enumeration e = getAgletContext().getAgletProxies();
         int i = 1;
         while (e.hasMoreElements()) {
            AgletProxy proxy = (AgletProxy)e.nextElement();
            System.out.print("No.: " + i++ + ": ");
            System.out.print(proxy.getAgletID() + " - ");
            System.out.print(proxy.getAgletInfo().getCodeBase() + " - ");
            System.out.println(proxy.getAgletClassName());
         }
      } catch (Exception e) { 
         print("Failed to list proxies.");
         print(e.getMessage());
      }
   }

   static public String NAME = "ProxyListing";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
}



