/*
 * @(#)ReplySetExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;

public class ReplySetExample extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
      	 print("Creating the subscribers...");
         getAgletContext().createAglet(getCodeBase(), 
                                       "agletbook.ReplySetChild", 
                                       "One");
         getAgletContext().createAglet(getCodeBase(), 
                                       "agletbook.ReplySetChild", 
                                       "Two");
         getAgletContext().createAglet(getCodeBase(), 
                                       "agletbook.ReplySetChild", 
                                       "Three");                                                          
         getAgletContext().createAglet(getCodeBase(), 
                                       "agletbook.ReplySetChild", 
                                       "Four");                                                          
         print("Finished creating the subscribers.");
	 pause();
         try {
	    print("Advertising presence in context...");
            Message msg = new Message("Hello Everybody");
            ReplySet replies = getAgletContext().multicastMessage(msg);
            print("Finished advertising.");
//	    replies.waitForAllReplies();
//	    print("All children have replied.");
            while (replies.hasMoreFutureReplies()) {
	       FutureReply future = replies.getNextFutureReply();
	       print("Got next future reply.");
	       print((String)future.getReply());
	    }
	    print("Finished.");
         } catch (Exception e) {
            print("Failed to multicast the message.");
            print(e.getMessage());         	
         }
      } catch (Exception e) { 
         print("Failed to create a subscriber.");
         print(e.getMessage());
      }
   }

   static public String NAME = "ReplySet";
   private void print(String s) { System.out.println(NAME + " (advertiser): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}




