/*
 * @(#)RetractableAglet.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.URL;

public class RetractableAglet extends Aglet {

   final int HOME      = 1;
   final int REMOTE    = 2;
   final int BACK_HOME = 3;

   int _status = HOME;

   public void onCreation(Object o) {
      addMobilityListener(
   	 new MobilityAdapter() {
	    public void onDispatching(MobilityEvent e) {
	       print("\'onDispatching()\' is starting...");
               print("\'onDispatching()\': Destination is \'" + e.getLocation() + "\'");	      	
               pause();
               print("\'onDispatching()\' is finishing.");
            }
	    public void onArrival(MobilityEvent e) {
	       _status = _status + 1;
	       print("\'onArrival()\' is starting...");
               pause();
               print("\'onArrival()\' is finishing.");
            }
	    public void onReverting(MobilityEvent e) {
               print("\'onReverting()\' is starting...");
               pause();
               print("\'onReverting()\' is finishing.");
            }
         }
      );	
   }   
   
   public void run() {
      if (_status == HOME) {
         print("STARTING --------------------");
         print("\'run()\' is starting...");
         pause();
         try {
            getAgletContext().setProperty("agletbook.retractID", getAgletID());
            print("Dispatching itself...");
            String host = getAgletContext().getHostingURL().toString();
            URL destination = new URL((String)getAgletContext().getProperty("location", host));
            print("Destination is \'" + destination.toString() + "\'");
            dispatch(destination);
            print("You should never see this on your console!");
         } catch (Exception e) { 
            print("Failed to dispatch itself.");
            print(e.getMessage());
         }      
         pause(); pause();
         print("\'run()\' is finishing.");
      } else if (_status == REMOTE) {
         print("\'run()\' is starting...");
         performTask();
         print("\'run()\' is finishing.");
      } else if (_status == BACK_HOME) {
         print("\'run()\' is starting...");
	 print("I'm back again!");
         pause();
         print("\'run()\' is finishing.");      	 
      }
   }

   private void performTask() {
      // Does whatever it is supposed to do.
      pause();
   }

   static public String NAME = "RetractableAglet";
   void print(String s) { System.out.println(NAME + (_status == REMOTE ? "   (remote): " : " (original): ") + s); }
   private static long SLEEP = 3000;
   void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}

