/*
 * @(#)RetractionExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;

import java.net.URL;

public class RetractionExample extends Aglet {

   public void run() {
      print("STARTING --------------------");
      try {
      	 print("Creating the child...");
         AgletProxy proxy = getAgletContext().createAglet(getCodeBase(), 
      	                                                  "agletbook.RetractionChild", 
      	                                                  null);
         try {
            String host = getAgletContext().getHostingURL().toString();
            URL destination = new URL((String)getAgletContext().getProperty("location", host));
            print("Destination is \'" + destination.toString() + "\'");
            print("Dispatching the child...");
            AgletID aid = proxy.getAgletID();
            proxy.dispatch(destination);
            print("Finished dispatching the child.");
            print("Retracting the child...");
            try {
               getAgletContext().retractAglet(destination, aid);
               print("Finished retracting the child.");
            }  catch (Exception e) { 
               print("Failed to retract the child.");
               print(e.getMessage());
            }
         }  catch (Exception e) { 
            print("Failed to dispatch the child.");
            print(e.getMessage());
         }
      } catch (Exception e) { 
         print("Failed to create the child.");
         print(e.getMessage());
      }
   }

   static public String NAME = "Retraction";
   private void print(String s) { System.out.println(NAME + " (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}





