/*
 * @(#)RetrievalExample.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import java.net.URL;

public class RetrievalExample extends Aglet {
   AgletID aid;

   public void run() {
      print("STARTING --------------------");
      try {
         print("Creating the first child...");
         aid = getAgletContext().createAglet(getCodeBase(), 
                                             "agletbook.RetrievalChild1", 
                                             null).getAgletID();
         print("Finished creating the first child.");
         try {
            print("Creating the second child...");
            getAgletContext().createAglet(getCodeBase(), 
                                          "agletbook.RetrievalChild2", 
                                          aid);
            print("Finished creating the second child.");
         } catch (Exception e) { 
            print("Failed to create the second child.");
            print(e.getMessage());
         }
      } catch (Exception e) { 
         print("Failed to create the first child.");
         print(e.getMessage());
      }
   }

   static public String NAME = "Retrieval";
   private void print(String s) { System.out.println(NAME + "  (parent): " + s); }
   private static long SLEEP = 3000;
   private void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}



