/*
 * @(#)SeqItinerary.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class SeqItinerary extends Itinerary {
	
   private Vector _destinations = null;

   SeqItinerary(URL origin, Vector destinations) {
      super(origin);
      _destinations = (Vector)destinations.clone();
   }

   public void go() {
      URL dest = getNextDestination();
      if (dest != null) {
         _destinations.removeElementAt(0);
         try {
            go(dest);
         } catch (Exception e) {
	   print("Failed to dispatch (" + dest + ")");
           print("Skip this destination and go for the next.");
	   print(e.getMessage());
           go();
         }
      }
   }

   public boolean hasMoreDestinations() {
      return _destinations.size() > 0;
   }

   public URL getNextDestination() {
      if (hasMoreDestinations())
         return (URL)_destinations.firstElement();
      else 
         return null;
   }
   
   static public String NAME = "SeqItinerary";
   void print(String s) { System.out.println(NAME + ": " + s); }   
}




