/*
 * @(#)Slave2.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */

package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;

public abstract class Slave2 extends Aglet {

   Itinerary itinerary = null;
   AgletProxy parent = null;

   public void onCreation(Object args) {
      try {
         itinerary = (Itinerary)((Object[])args)[0];
         parent = (AgletProxy)((Object[])args)[1];         
	 initializeTask();
         addMobilityListener(
   	    new MobilityAdapter() {
	       public void onArrival(MobilityEvent me) {
	          print("Arrived...");
	          try {
                     parent.sendMessage(new Message("Result", doTask()));
		     if (itinerary.hasMoreDestinations()) {
                        print("Going...");
                        itinerary.go();
		     } else {
                        print("Done...");
			dispose();
		     }
		  } catch (Exception e) {
	             print("Failed to send result to master.");
		     print(e.getMessage());
		  }
               }
            }
         );	
         itinerary.init(this);
      } catch (Exception e) {
         print("Failed to create slave.");
	 print(e.getMessage());
      }
   }   

   abstract void initializeTask();

   abstract Object doTask();

   static public String NAME = "Slave2";
   void print(String s) { System.out.println(NAME + ": " + s); }
}



