/*
 * @(#)Traveller.java
 *
 * (c) Copyright Danny B. Lange & Mitsuru Oshima, 1998
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY 
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, 
 * THE WARRANTY OF NON-INFRINGEMENT AND THE WARRANTIES 
 * OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * THE AUTHORS WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY YOU AS A RESULT OF USING THIS SAMPLE PROGRAM. IN NO 
 * EVENT WILL THE AUTHORS BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT CONSEQUENTIAL DAMAGES OR LOST PROFITS EVEN IF 
 * THE AUTHORS HAS BEEN ADVISED OF THE POSSIBILITY OF 
 * THEIR OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS 
 * OR DATA. THE AUTHORS WILL NOT BE LIABLE FOR ANY THIRD 
 * PARTY CLAIMS AGAINST YOU.
 */
 
package agletbook;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;

public class Traveller extends Aglet {

   Register _register = null;

   public void onCreation(Object o) {
      AgletProxy finder = (AgletProxy)getAgletContext().getProperty("AgletFinder");
      _register = new Register(finder, "Traveller");
      addMobilityListener(_register);	

      try {
         print("Dispatching itself...");
         String host = getAgletContext().getHostingURL().toString();
         URL destination = new URL((String)getAgletContext().getProperty("agletbook.location", host));
         print("Destination is \'" + destination.toString() + "\'");
         dispatch(destination);
         print("You should never see this on your console!");
      } catch (Exception e) { 
         print("Failed to dispatch itself.");
         print(e.getMessage());
      }         
   }   

   public void onDisposing() {
      _register.unregister();
   }

   public boolean handleMessage(Message msg) {
      if (msg.sameKind("Hello"))
         print("Handling \'Hello\'");
      return true;
   }


   static public String NAME = "Traveller";
   private void print(String s) { System.out.println(NAME + ": " + s); }
   static long SLEEP = 3000;
   void pause() { try { Thread.sleep(SLEEP); } catch (InterruptedException ie) { } }
}





